const _is                   = require("nv-validator-json-is");
    const {_un,_nu,_t,_f,is_ary_idx,_S}   = _is;
const _tree                 = require("nv-data-tree-csp-tuple-bw");
const _pl                   = require("nv-validator-json-pl");
const _T                    = require("./t").N2SEQ;
const _func                 = require("./func");


const _init_nj = (pl,j) => {
    let nj      = j;
    if(pl.length ===1) {
    } else {
        let npl = pl.slice(1);
        nj = _pl.pldflt(npl,nj)
    }
    return(nj)
}

const DFLT_CLONE_FUNC = (nd,nnd)=>{
    for(let i=3;i<8;i++) {
        nnd[i] = nd[i]
    }
}



class Node extends _tree._Node {
    constructor(
        forest=null,id=-1,blocked=_f,
        T=_T.un,
        val=_un,
        key=_un,
        calced=_un,
        required=_t,
        dtype=_un
    ) {
        super(forest,id,blocked);
        this[3] = T;
        this[4] = val;
        this[5] = key;
        this[6] = calced;
        this[7] = required;
        this[8] = dtype; 
    }
    ////
    get required_()       {return(this[7])}
    is_optional()         {return(!this[7])}
    is_required()         {return(this[7])}
    optional()            {this[7]=_f}
    require()             {this[7]=_t}
    ////
    get typ_()            {return(this[3])}
    set_typ_to_ary()      {this[3]=_T.ary}
    set_typ_to_dict()     {this[3]=_T.dict}
    is_ary()              {return(this[3]===_T.ary)}
    is_dict()             {return(this[3]===_T.dict)}
    is_container()        {return(this.is_ary() || this.is_dict())}
    is_leaf()             {return(!this.is_container())}
    ////
    get ["#calced_"]()    {return(this[6])}
    set ["#calced_"](j)   {this[6] = j}
    ["#clear_calced"]()   {this[6] =_un}
    ////---for future using v8.serialize v8.deserialize
    get dtype_()          {return(this[8])}
    ////
    calc(
         leaf_func= _func.DFLT_LEAF_FUNC,
         del_rslt_after_calc=_t
    ) {
         if(del_rslt_after_calc) {
             return(_func._calc_and_del_rslt(this,leaf_func)) 
         } else {
             return(_func._calc_and_keep_rslt(this,leaf_func))
         }
    }
    dump_for_light_nvdbj(del_rslt_after_calc=_t) {
         return(this.calc(_func.LIGHT_NVDBJ_LEAF_FUNC,del_rslt_after_calc))   
    }
    //load_from_nvdbj(nvdbj){} 
    ////   nd created-from creat_nvdbj_shape
    calc_treat_null_as_empty() {
       return(_func._calc_treat_null_as_empty(this))
    }
    dump_for_light_nvdbj_treat_null_as_empty() {
       return(_func._calc_treat_null_as_empty_for_light_nvdbj(this)) 
    }
    ////
    reset_calced() {
        let g = this.$gen_sdfs_next();
        for(let nd of g) {
            nd[6] = _un
        }
    }
    creat_jtmpl()        {return(_func._calc_and_del_rslt(this,(self)=>_un))}
    dump_for_validator() {
        let jvali     = _func._calc_and_del_rslt(this,(leaf)=>leaf.val_.toString()); 
        let jrequired = [];
        let g  = this.$gen_sdfs_next();
        for(let nd of g) {
            let pl       = nd.pl_;
            jrequired.push([pl, nd.required_]);
        }
        return({jvali,jrequired})
    }
    ////    
    is_root()       {return(this[5]===_nu)}
    _is_ele()       { return(this.$parent_.is_ary())}
    is_ele()        {
        if(this.is_root()) {
            return(_f)
        } else {
            return(this._is_ele())
        }
    }
    _is_prop()      { return(this.$parent_.is_dict())}
    is_prop()       {
        if(this.is_root()) {
            return(_f)
        } else {
            return(this._is_dict())
        }
    }
    ////
    get val_()            {return(this[4])}
    get key_()            {return(this[5])}
    get idx_()            {return(this.$sibseq_)}
    get koi_()            {
        if(this.is_root()) {
            return(_nu)
        } else if(this._is_ele()) {
            return(this.idx_)
        } else {
            return(this.key_)
        }
    }
    get pl_()             {
        let pl = this.$plances_.slice(1);
        pl = pl.map(nd=>nd.koi_);
        return(pl)
    }
    get pls_() {
        let sdfs = this.$sdfs_;
        return(sdfs.map(nd=>nd.pl_))
    }
    ////
    ////
    append_leaf(v,k=_un) {
        let chnd = this.$append_child();
        chnd[4]  = v;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_leaf(v,k=_un)  {
        let rsibnd = this.$add_rsib();
        rsibnd[4]  = v;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_leaf(v,k=_un)  {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = v;
        lsibnd[5]  = k;
        return(lsibnd)
    }
    ////
    append_ary(k=_un)   {
        let chnd = this.$append_child();
        chnd[3]  = _T.ary;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_ary(k=_un)    {
        let rsibnd = this.$add_rsib();
        rsibnd[3]  = _T.ary;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_ary(k=_un)    {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = _T.ary;
        lsibnd[5]  = k;
        return(lsibnd)
    }    
    append_dict(k=_un)  {
        let chnd = this.$append_child();
        chnd[3]  = _T.dict;
        chnd[5]  = k;
        return(chnd)
    }
    arsib_dict(k=_un)   {
        let rsibnd = this.$add_rsib();
        rsibnd[3]  = _T.dict;
        rsibnd[5]  = k;
        return(rsibnd)
    }
    alsib_dict(k=_un)   {
        let lsibnd = this.$add_lsib();
        lsibnd[4]  = _T.dict;
        lsibnd[5]  = k;
        return(lsibnd)
    }
    ///
    append(j,k=_un)     {
        let forest = this.$forest_;
        let Ctor   = this.constructor;
        if(this.is_ary()) {
            let chnd = _func.creat_from_j(forest,Ctor,j);
            this.$append_child(chnd);
            return(chnd)
        } else if(this.is_dict()) {
            let chnd = _func.creat_from_j(forest,Ctor,j);
            chnd[5] = k;
            this.$append_child(chnd);
            return(chnd) 
        } else {
            return(_nu)
        }
    }
    arsib(j,k=_un)      {
        if(this.is_root()) {
            return(_nu)
        } else {
            let forest = this.$forest_;
            let Ctor   = this.constructor;
            let rsibnd = _func.creat_from_j(forest,Ctor,j);
            rsibnd[5]  = k;
            this.$add_rsib(rsibnd);
            return(rsibnd)
        }
    }
    alsib(j,k=_un)      {
        if(this.is_root()) {
            return(_nu)
        } else {
            let forest = this.$forest_;
            let Ctor   = this.constructor;
            let lsibnd = _func.creat_from_j(forest,Ctor,j);
            lsibnd[5] = k;
            this.$add_lsib(lsibnd);
            return(lsibnd)
        }
    }
    //
    koiget_chnd(koi) {
        if(this.is_ary()) {
            let g = this.$gen_child_from_fst();
            let idx = 0;
            for(let chnd of g) {
                if(idx === koi) {
                    return(chnd)
                } else {}
                idx++;
            }
            return(_nu)
        } else if(this.is_dict()) {
            let g = this.$gen_child_from_fst();
            for(let chnd of g) {
                if(chnd.key_ === koi) {
                    return(chnd)
                } else {}
            }
            return(_nu)            
        } else {
            return(_nu)
        }
    }
    plget_nd(pl=[]) {
        let lngth = pl.length;
        if(lngth === 0) {
            return(this)
        } else {
            let pnd = this;
            for(let i=0;i<lngth;i++) {
                let koi = pl[i];
                pnd = pnd.koiget_chnd(koi);
                if(pnd!==_nu) {
                } else {
                    return(_nu)
                }
            }
            return(pnd)
        }
    }
    plget_jr(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd === _nu) {
            return([_un,_un])
        } else {
            let r = nd.required_;
            let j = nd.calc();
            return([j,r])
        }
    }
    plget_j(pl=[]) {return(this.plget_jr(pl)[0])}
    ////
    plget_vr(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd === _nu) {
            return([_un,_un])
        } else {
            let r = nd[7];  //required
            let v = nd[4];  //val_
            return([v,r])
        }
    }
    plget_v(pl=[]) {return(this.plget_vr(pl)[0])}
    plget_r(pl=[]) {return(this.plget_vr(pl)[1])}
    ////
    pl_disconn(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd) {
            let j  = nd.calc();
            nd.$disconn();
            return(nd)
        } else {
            return(_nu)
        }
    }
    //
    pldel(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd) {
            let j  = nd.calc();
            nd.$erase_r();
            return(j)
        } else {
            return(_un)
        }
    }
    pl_nudel(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd) {
            nd[4]= _nu;
            return(nd)
        } else {
            return(_un)
        }
    }
    pl_nu_recover_container(pl=[]) {
        let nd = this.plget_nd(pl);
        if(nd) {
            if(nd.is_container()) {
                nd[4]= _un;
            } else {}
            return(nd)
        } else {
            return(_un)
        }        
    }
    plupdt(pl=[],j,k=_un) {
        let nd     = this.plget_nd(pl);
        if(nd) {
            if(nd.is_root() && pl.length ===0) {
                ////
                let nnd = _func.creat_from_j(this.$forest_,this.constructor,j);
                for(let i=3;i<8;i++) {nd[i] = nnd[i];}
                let children = nd.$children_;
                for(let chnd of children) {
                    chnd.$erase_r();
                }
                children = nnd.$children_;
                for(let chnd of children) {
                    chnd.$disconn();
                    nd.$append_child(chnd);
                }
                nnd.$erase();
                ////
                return(nd)
            } else {
                let nnd;
                let lb = nd.$lsib_;
                if(lb) {
                    nnd = lb.arsib(j,k);
                } else {
                    let pr  = nd.$parent_;
                    nnd = pr.append(j,k)
                }
                nd.$erase_r();
                return(nnd)
            }
        } else {
            return(_un)
        }
    }
    plset(pl=[],j,k=_un) {
        let pnd = this.plget_nd(pl.slice(0,pl.length-1));
        if(pnd) {
            let nd = pnd.koiget_chnd(koi);
            if(nd) {
                console.log('already_exist_please_use_plupdt')
                return(_un);
            } else {
                nd = pnd.append(j,k);
                return(nd)
            }
        } else {
            return(_un)
        }
    }
    plset_dflt(pl=[],j,k=_un) {
        let nd  = this;
        let i   = 0;
        while(i<pl.length) {
            let koi = pl[i];
            let chnd = nd.koiget_chnd(koi);
            if(chnd) {
                nd=chnd;
                i++;
            } else {
                break;        
            }
        }
        if(i===pl.length) {
            return(nd.plupdt([],j,k))
        } else {
            pl          = pl.slice(i);
            let fst_koi = pl[0];
            if(nd.is_ary()) {
                let nj = _init_nj(pl,j);
                let curr_len = nd.$children_.length;
                for(let idx=curr_len;idx<fst_koi;idx++) {
                    nd.append_leaf(_nu);
                }
                return(nd.append(nj))
            } else if(nd.is_dict()) {
                let nj = _init_nj(pl,j);
                let k = _S(fst_koi);
                return(nd.append(nj,k))
            } else {
                return(_un)
            }
        }
    }
    ////
    clone(clone_func=DFLT_CLONE_FUNC) {
        let nrt = this.$clone(clone_func);
        nrt[5] = _nu;
        return(nrt)
    }
}

Node.DFLT_CLONE_FUNC = DFLT_CLONE_FUNC;

Node.ALGN_DESC    = ["typ_","val_","key_","#calced_","required_","dtype_"];
Node.ALGN_OFFSET  = 3;
Node.ALGN_SIZE    = 6;

module.exports    = Node;
